/[gentoo-x86]/eclass/flag-o-matic.eclass
Gentoo

Diff of /eclass/flag-o-matic.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.62 Revision 1.117
1# Copyright 1999-2004 Gentoo Foundation 1# Copyright 1999-2007 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/flag-o-matic.eclass,v 1.62 2004/07/15 04:59:44 lv Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/flag-o-matic.eclass,v 1.117 2007/03/04 21:13:17 vapier Exp $
4# 4#
5# Author Bart Verwilst <verwilst@gentoo.org> 5# Maintainer: toolchain@gentoo.org
6 6
7ECLASS=flag-o-matic 7# need access to emktemp()
8INHERITED="$INHERITED $ECLASS" 8inherit eutils toolchain-funcs multilib
9IUSE="$IUSE debug"
10 9
11# 10#
12#### filter-flags <flags> #### 11#### filter-flags <flags> ####
13# Remove particular flags from C[XX]FLAGS 12# Remove particular flags from C[XX]FLAGS
14# Matches only complete flags 13# Matches only complete flags
17# Add extra flags to your current C[XX]FLAGS 16# Add extra flags to your current C[XX]FLAGS
18# 17#
19#### replace-flags <orig.flag> <new.flag> ### 18#### replace-flags <orig.flag> <new.flag> ###
20# Replace a flag by another one 19# Replace a flag by another one
21# 20#
22#### replace-cpu-flags <new.cpu> <old.cpus> ### 21#### replace-cpu-flags <old.cpus> <new.cpu> ###
23# Replace march/mcpu flags that specify <old.cpus> 22# Replace march/mcpu flags that specify <old.cpus>
24# with flags that specify <new.cpu> 23# with flags that specify <new.cpu>
25# 24#
26#### is-flag <flag> #### 25#### is-flag[q] <flag> ####
27# Returns "true" if flag is set in C[XX]FLAGS 26# Returns "true" if flag is set in C[XX]FLAGS
28# Matches only complete a flag 27# Matches only complete a flag
28# q version sets return code but doesn't echo
29#
30#### is-ldflag[q] <flag> ####
31# Returns "true" if flag is set in LDFLAGS
32# Matches only complete a flag
33# q version sets return code but doesn't echo
29# 34#
30#### strip-flags #### 35#### strip-flags ####
31# Strip C[XX]FLAGS of everything except known 36# Strip C[XX]FLAGS of everything except known
32# good options. 37# good options.
33# 38#
52# 57#
53#### filter-ldflags <flags> #### 58#### filter-ldflags <flags> ####
54# Remove particular flags from LDFLAGS 59# Remove particular flags from LDFLAGS
55# Matches only complete flags 60# Matches only complete flags
56# 61#
57#### etexec-flags #### 62#### bindnow-flags ####
58# hooked function for hardened gcc that appends 63# Returns the flags to enable "now" binding in the current selected linker.
59# -fno-pic to {C,CXX,LD}FLAGS
60# when a package is filtering -fpic, -fPIC, -fpie, -fPIE
61# 64#
62#### fstack-flags #### 65################ DEPRECATED functions ################
63# hooked function for hardened gcc that appends 66# The following are still present to avoid breaking existing
64# -fno-stack-protector to {C,CXX,LD}FLAGS 67# code more than necessary; however they are deprecated. Please
65# when a package is filtering -fstack-protector, -fstack-protector-all 68# use gcc-specs-* from toolchain-funcs.eclass instead, if you
66# notice: modern automatic specs files will also suppress -fstack-protector-all 69# need to know which hardened techs are active in the compiler.
67# when only -fno-stack-protector is given 70# See bug #100974
71#
72#### has_hardened ####
73# Returns true if the compiler has 'Hardened' in its version string,
74# (note; switched-spec vanilla compilers satisfy this condition) or
75# the specs file name contains 'hardened'.
76#
77#### has_pie ####
78# Returns true if the compiler by default or with current CFLAGS
79# builds position-independent code.
80#
81#### has_pic ####
82# Returns true if the compiler by default or with current CFLAGS
83# builds position-independent code.
84#
85#### has_ssp_all ####
86# Returns true if the compiler by default or with current CFLAGS
87# generates stack smash protections for all functions
88#
89#### has_ssp ####
90# Returns true if the compiler by default or with current CFLAGS
91# generates stack smash protections for most vulnerable functions
68# 92#
69 93
70# C[XX]FLAGS that we allow in strip-flags 94# C[XX]FLAGS that we allow in strip-flags
95# Note: shell globs and character lists are allowed
71setup-allowed-flags() { 96setup-allowed-flags() {
72 if [ -z "${ALLOWED_FLAGS}" ] ; then 97 if [[ -z ${ALLOWED_FLAGS} ]] ; then
73 export ALLOWED_FLAGS="-O -O1 -O2 -mcpu -march -mtune -fstack-protector -fno-unit-at-a-time -pipe -g" 98 export ALLOWED_FLAGS="-pipe"
74 case "${ARCH}" in 99 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -O -O0 -O1 -O2 -mcpu -march -mtune"
75 mips) ALLOWED_FLAGS="${ALLOWED_FLAGS} -mips1 -mips2 -mips3 -mips4 -mabi" ;; 100 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fstack-protector -fstack-protector-all"
76 amd64) ALLOWED_FLAGS="${ALLOWED_FLAGS} -fPIC -m64" ;; 101 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fbounds-checking -fno-bounds-checking"
77 x86) ALLOWED_FLAGS="${ALLOWED_FLAGS} -m32" ;; 102 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-PIE -fno-pie -fno-unit-at-a-time"
78 alpha) ALLOWED_FLAGS="${ALLOWED_FLAGS} -fPIC" ;; 103 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -g -g[0-9] -ggdb -ggdb[0-9] -gstabs -gstabs+"
79 ia64) ALLOWED_FLAGS="${ALLOWED_FLAGS} -fPIC" ;; 104 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-ident"
80 esac
81 fi 105 fi
106 # allow a bunch of flags that negate features / control ABI
107 ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-stack-protector -fno-stack-protector-all"
108 ALLOWED_FLAGS="${ALLOWED_FLAGS} -mregparm -mno-app-regs -mapp-regs \
109 -mno-mmx -mno-sse -mno-sse2 -mno-sse3 -mno-3dnow \
110 -mips1 -mips2 -mips3 -mips4 -mips32 -mips64 -mips16 \
111 -msoft-float -mno-soft-float -mhard-float -mno-hard-float -mfpu \
112 -mieee -mieee-with-inexact -mschedule \
113 -mtls-direct-seg-refs -mno-tls-direct-seg-refs \
114 -mflat -mno-flat -mno-faster-structs -mfaster-structs \
115 -m32 -m64 -mabi -mlittle-endian -mbig-endian -EL -EB -fPIC \
116 -mlive-g0 -mcmodel -mstack-bias -mno-stack-bias \
117 -msecure-plt -D*"
82 118
83 # C[XX]FLAGS that we are think is ok, but needs testing 119 # C[XX]FLAGS that we are think is ok, but needs testing
84 # NOTE: currently -Os have issues with gcc3 and K6* arch's 120 # NOTE: currently -Os have issues with gcc3 and K6* arch's
85 export UNSTABLE_FLAGS="-Os -O3 -freorder-blocks -fprefetch-loop-arrays" 121 export UNSTABLE_FLAGS="-Os -O3 -freorder-blocks"
86 return 0 122 return 0
123}
124
125# inverted filters for hardened compiler. This is trying to unpick
126# the hardened compiler defaults.
127_filter-hardened() {
128 local f
129 for f in "$@" ; do
130 case "${f}" in
131 # Ideally we should only concern ourselves with PIE flags,
132 # not -fPIC or -fpic, but too many places filter -fPIC without
133 # thinking about -fPIE.
134 -fPIC|-fpic|-fPIE|-fpie|-Wl,pie|-pie)
135 gcc-specs-pie || continue
136 is-flagq -nopie || append-flags -nopie;;
137 -fstack-protector)
138 gcc-specs-ssp || continue
139 is-flagq -fno-stack-protector || append-flags -fno-stack-protector;;
140 -fstack-protector-all)
141 gcc-specs-ssp-to-all || continue
142 is-flagq -fno-stack-protector-all || append-flags -fno-stack-protector-all;;
143 esac
144 done
145}
146
147# Remove occurrences of strings from variable given in $1
148# Strings removed are matched as globs, so for example
149# '-O*' would remove -O1, -O2 etc.
150_filter-var() {
151 local f x VAR VAL
152 declare -a new
153
154 VAR=$1
155 shift
156 eval VAL=\${${VAR}}
157 for f in ${VAL}; do
158 for x in "$@"; do
159 # Note this should work with globs like -O*
160 [[ ${f} == ${x} ]] && continue 2
161 done
162 eval new\[\${\#new\[@]}]=\${f}
163 done
164 eval export ${VAR}=\${new\[*]}
87} 165}
88 166
89filter-flags() { 167filter-flags() {
90 local x f fset 168 _filter-hardened "$@"
91 declare -a new_CFLAGS new_CXXFLAGS 169 _filter-var CFLAGS "$@"
92 170 _filter-var CXXFLAGS "$@"
93 for x in "$@" ; do
94 case "${x}" in
95 -fPIC|-fpic|-fPIE|-fpie|-pie) etexec-flags;;
96 -fstack-protector|-fstack-protector-all) fstack-flags;;
97 esac
98 done
99
100 for fset in CFLAGS CXXFLAGS; do
101 for f in ${!fset}; do
102 for x in "$@"; do
103 # Note this should work with globs like -O*
104 [[ ${f} == ${x} ]] && continue 2
105 done
106 eval new_${fset}\[\${\#new_${fset}\[@]}]=\${f}
107 done
108 eval export ${fset}=\${new_${fset}\[*]}
109 done
110
111 return 0 171 return 0
112} 172}
113 173
114filter-lfs-flags() { 174filter-lfs-flags() {
175 [[ -n $@ ]] && die "filter-lfs-flags takes no arguments"
115 filter-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE 176 filter-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
116} 177}
117 178
118append-lfs-flags() { 179append-lfs-flags() {
180 [[ -n $@ ]] && die "append-lfs-flags takes no arguments"
119 append-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE 181 append-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
120} 182}
121 183
122append-flags() { 184append-flags() {
185 [[ -z $* ]] && return 0
123 export CFLAGS="${CFLAGS} $*" 186 export CFLAGS="${CFLAGS} $*"
124 export CXXFLAGS="${CXXFLAGS} $*" 187 export CXXFLAGS="${CXXFLAGS} $*"
125 [ -n "`is-flag -fno-stack-protector`" -o \
126 -n "`is-flag -fno-stack-protector-all`" ] && fstack-flags
127 return 0 188 return 0
128} 189}
129 190
130replace-flags() { 191replace-flags() {
131 # we do this fancy spacing stuff so as to not filter 192 [[ $# != 2 ]] \
132 # out part of a flag ... we want flag atoms ! :D 193 && echo && eerror "Usage: replace-flags <old flag> <new flag>" \
133 CFLAGS=" ${CFLAGS} " 194 && die "replace-flags takes 2 arguments, not $#"
134 CXXFLAGS=" ${CXXFLAGS} " 195
135 CFLAGS="${CFLAGS// ${1} / ${2} }" 196 local f fset
136 CXXFLAGS="${CXXFLAGS// ${1} / ${2} }" 197 declare -a new_CFLAGS new_CXXFLAGS
137 CFLAGS="${CFLAGS:1:${#CFLAGS}-2}" 198
138 CXXFLAGS="${CXXFLAGS:1:${#CXXFLAGS}-2}" 199 for fset in CFLAGS CXXFLAGS; do
139 export CFLAGS CXXFLAGS 200 # Looping over the flags instead of using a global
201 # substitution ensures that we're working with flag atoms.
202 # Otherwise globs like -O* have the potential to wipe out the
203 # list of flags.
204 for f in ${!fset}; do
205 # Note this should work with globs like -O*
206 [[ ${f} == ${1} ]] && f=${2}
207 eval new_${fset}\[\${\#new_${fset}\[@]}]=\${f}
208 done
209 eval export ${fset}=\${new_${fset}\[*]}
210 done
211
140 return 0 212 return 0
141} 213}
142 214
143replace-cpu-flags() { 215replace-cpu-flags() {
144 local oldcpu newcpu="$1" ; shift 216 local newcpu="$#" ; newcpu="${!newcpu}"
145 for oldcpu in "$@" ; do 217 while [ $# -gt 1 ] ; do
218 # quote to make sure that no globbing is done (particularly on
219 # ${oldcpu}) prior to calling replace-flags
146 replace-flags -march=${oldcpu} -march=${newcpu} 220 replace-flags "-march=${1}" "-march=${newcpu}"
147 replace-flags -mcpu=${oldcpu} -mcpu=${newcpu} 221 replace-flags "-mcpu=${1}" "-mcpu=${newcpu}"
148 replace-flags -mtune=${oldcpu} -mtune=${newcpu} 222 replace-flags "-mtune=${1}" "-mtune=${newcpu}"
223 shift
149 done 224 done
225 return 0
226}
227
228_is_flagq() {
229 local x
230 for x in ${!1} ; do
231 [[ ${x} == $2 ]] && return 0
232 done
150 return 0 233 return 1
234}
235
236is-flagq() {
237 [[ -n $2 ]] && die "Usage: is-flag <flag>"
238 _is_flagq CFLAGS $1 || _is_flagq CXXFLAGS $1
151} 239}
152 240
153is-flag() { 241is-flag() {
154 local x 242 is-flagq "$@" && echo true
243}
155 244
156 for x in ${CFLAGS} ${CXXFLAGS} ; do 245is-ldflagq() {
157 if [ "${x}" == "$1" ] ; then 246 [[ -n $2 ]] && die "Usage: is-ldflag <flag>"
158 echo true 247 _is_flagq LDFLAGS $1
159 return 0 248}
160 fi 249
161 done 250is-ldflag() {
162 return 1 251 is-ldflagq "$@" && echo true
163} 252}
164 253
165filter-mfpmath() { 254filter-mfpmath() {
166 local orig_mfpmath new_math prune_math 255 local orig_mfpmath new_math prune_math
167 256
168 # save the original -mfpmath flag 257 # save the original -mfpmath flag
169 orig_mfpmath="`get-flag -mfpmath`" 258 orig_mfpmath=$(get-flag -mfpmath)
170 # get the value of the current -mfpmath flag 259 # get the value of the current -mfpmath flag
171 new_math=" `get-flag mfpmath | tr , ' '` " 260 new_math=$(get-flag mfpmath)
261 new_math=" ${new_math//,/ } "
172 # figure out which math values are to be removed 262 # figure out which math values are to be removed
173 prune_math="" 263 prune_math=""
174 for prune_math in "$@" ; do 264 for prune_math in "$@" ; do
175 new_math="${new_math/ ${prune_math} / }" 265 new_math=${new_math/ ${prune_math} / }
176 done 266 done
177 new_math="`echo ${new_math:1:${#new_math}-2} | tr ' ' ,`" 267 new_math=$(echo ${new_math})
268 new_math=${new_math// /,}
178 269
179 if [ -z "${new_math}" ] ; then 270 if [[ -z ${new_math} ]] ; then
180 # if we're removing all user specified math values are 271 # if we're removing all user specified math values are
181 # slated for removal, then we just filter the flag 272 # slated for removal, then we just filter the flag
182 filter-flags ${orig_mfpmath} 273 filter-flags ${orig_mfpmath}
183 else 274 else
184 # if we only want to filter some of the user specified 275 # if we only want to filter some of the user specified
195 286
196 local NEW_CFLAGS="" 287 local NEW_CFLAGS=""
197 local NEW_CXXFLAGS="" 288 local NEW_CXXFLAGS=""
198 289
199 # Allow unstable C[XX]FLAGS if we are using unstable profile ... 290 # Allow unstable C[XX]FLAGS if we are using unstable profile ...
200 if has ~${ARCH} ${ACCEPT_KEYWORDS} ; then 291 if has ~$(tc-arch) ${ACCEPT_KEYWORDS} ; then
201 use debug && einfo "Enabling the use of some unstable flags"
202 ALLOWED_FLAGS="${ALLOWED_FLAGS} ${UNSTABLE_FLAGS}" 292 ALLOWED_FLAGS="${ALLOWED_FLAGS} ${UNSTABLE_FLAGS}"
203 fi 293 fi
204 294
205 set -f # disable pathname expansion 295 set -f # disable pathname expansion
206 296
207 for x in ${CFLAGS}; do 297 for x in ${CFLAGS}; do
208 for y in ${ALLOWED_FLAGS}; do 298 for y in ${ALLOWED_FLAGS}; do
209 flag=${x%%=*} 299 flag=${x%%=*}
210 if [ "${flag%%${y}}" = "" ]; then 300 if [ "${flag%%${y}}" = "" ] ; then
211 NEW_CFLAGS="${NEW_CFLAGS} ${x}" 301 NEW_CFLAGS="${NEW_CFLAGS} ${x}"
212 break 302 break
213 fi 303 fi
214 done 304 done
215 done 305 done
216 306
217 for x in ${CXXFLAGS}; do 307 for x in ${CXXFLAGS}; do
218 for y in ${ALLOWED_FLAGS}; do 308 for y in ${ALLOWED_FLAGS}; do
219 flag=${x%%=*} 309 flag=${x%%=*}
220 if [ "${flag%%${y}}" = "" ]; then 310 if [ "${flag%%${y}}" = "" ] ; then
221 NEW_CXXFLAGS="${NEW_CXXFLAGS} ${x}" 311 NEW_CXXFLAGS="${NEW_CXXFLAGS} ${x}"
222 break 312 break
223 fi 313 fi
224 done 314 done
225 done 315 done
237 export CFLAGS="${NEW_CFLAGS}" 327 export CFLAGS="${NEW_CFLAGS}"
238 export CXXFLAGS="${NEW_CXXFLAGS}" 328 export CXXFLAGS="${NEW_CXXFLAGS}"
239 return 0 329 return 0
240} 330}
241 331
332test-flag-PROG() {
333 local comp=$1
334 local flags="$2"
335
336 [[ -z ${comp} || -z ${flags} ]] && \
337 return 1
338
339 local PROG=$(tc-get${comp})
340 ${PROG} ${flags} -S -o /dev/null -xc /dev/null \
341 > /dev/null 2>&1
342}
343
344# Returns true if C compiler support given flag
345test-flag-CC() { test-flag-PROG "CC" "$1"; }
346
347# Returns true if C++ compiler support given flag
348test-flag-CXX() { test-flag-PROG "CXX" "$1"; }
349
350test-flags-PROG() {
351 local comp=$1
352 local flags
353 local x
354
355 shift
356
357 [[ -z ${comp} ]] && return 1
358
359 x=""
360 for x in "$@" ; do
361 test-flag-${comp} "${x}" && flags="${flags}${flags:+ }${x}"
362 done
363
364 echo "${flags}"
365
366 # Just bail if we dont have any flags
367 [[ -n ${flags} ]]
368}
369
370# Returns (echo's) the given flags supported by the C compiler
371test-flags-CC() { test-flags-PROG "CC" "$@"; }
372
373# Returns (echo's) the given flags supported by the C++ compiler
374test-flags-CXX() { test-flags-PROG "CXX" "$@"; }
375
376# Short-hand that should hopefully work for both C and C++ compiler, but
377# its really only present due to the append-flags() abomination.
378test-flags() { test-flags-CC "$@"; }
379
380# Depriciated, use test-flags()
242test_flag() { 381test_flag() {
243 local cc=${CC:-gcc} ; cc=${cc%% *} 382 ewarn "test_flag: deprecated, please use test-flags()!" >&2
244 if ${cc} -S -xc "$@" -o /dev/null /dev/null &>/dev/null; then 383
245 printf "%s\n" "$*" 384 test-flags-CC "$@"
246 return 0
247 fi
248 return 1
249} 385}
250 386
251test_version_info() { 387test_version_info() {
252 local cc=${CC:-gcc} ; cc=${cc%% *}
253 if [[ $(${cc} --version 2>&1) == *$1* ]]; then 388 if [[ $($(tc-getCC) --version 2>&1) == *$1* ]]; then
254 return 0 389 return 0
255 else 390 else
256 return 1 391 return 1
257 fi 392 fi
258} 393}
259 394
260strip-unsupported-flags() { 395strip-unsupported-flags() {
261 local NEW_CFLAGS NEW_CXXFLAGS 396 export CFLAGS=$(test-flags-CC ${CFLAGS})
262 397 export CXXFLAGS=$(test-flags-CXX ${CXXFLAGS})
263 for x in ${CFLAGS} ; do
264 NEW_CFLAGS="${NEW_CFLAGS} `test_flag ${x}`"
265 done
266 for x in ${CXXFLAGS} ; do
267 NEW_CXXFLAGS="${NEW_CXXFLAGS} `test_flag ${x}`"
268 done
269
270 export CFLAGS="${NEW_CFLAGS}"
271 export CXXFLAGS="${NEW_CXXFLAGS}"
272} 398}
273 399
274get-flag() { 400get-flag() {
275 local f findflag="$1" 401 local f findflag="$1"
276 402
286 fi 412 fi
287 done 413 done
288 return 1 414 return 1
289} 415}
290 416
417# DEPRECATED - use gcc-specs-relro or gcc-specs-now from toolchain-funcs
291has_hardened() { 418has_hardened() {
419 ewarn "has_hardened: deprecated, please use gcc-specs-{relro,now}()!" >&2
420
292 test_version_info Hardened 421 test_version_info Hardened && return 0
293 return $? 422 # The specs file wont exist unless gcc has GCC_SPECS support
423 [[ -f ${GCC_SPECS} && ${GCC_SPECS} != ${GCC_SPECS/hardened/} ]]
294} 424}
295 425
426# DEPRECATED - use gcc-specs-pie from toolchain-funcs
427# indicate whether PIC is set
296has_pic() { 428has_pic() {
297 [ "${CFLAGS/-fPIC}" != "${CFLAGS}" ] && return 0 429 ewarn "has_pic: deprecated, please use gcc-specs-pie()!" >&2
298 [ "${CFLAGS/-fpic}" != "${CFLAGS}" ] && return 0
299 test_version_info pie && return 0
300 return 1
301}
302 430
431 [[ ${CFLAGS/-fPIC} != ${CFLAGS} || \
432 ${CFLAGS/-fpic} != ${CFLAGS} ]] || \
433 gcc-specs-pie
434}
435
436# DEPRECATED - use gcc-specs-pie from toolchain-funcs
437# indicate whether PIE is set
303has_pie() { 438has_pie() {
304 [ "${CFLAGS/-fPIE}" != "${CFLAGS}" ] && return 0 439 ewarn "has_pie: deprecated, please use gcc-specs-pie()!" >&2
305 [ "${CFLAGS/-fpie}" != "${CFLAGS}" ] && return 0 440
306 test_version_info pie && return 0 441 [[ ${CFLAGS/-fPIE} != ${CFLAGS} || \
307 return 1 442 ${CFLAGS/-fpie} != ${CFLAGS} ]] || \
443 gcc-specs-pie
308} 444}
309 445
446# DEPRECATED - use gcc-specs-ssp from toolchain-funcs
447# indicate whether code for SSP is being generated for all functions
448has_ssp_all() {
449 ewarn "has_ssp_all: deprecated, please use gcc-specs-ssp()!" >&2
450
451 # note; this matches only -fstack-protector-all
452 [[ ${CFLAGS/-fstack-protector-all} != ${CFLAGS} || \
453 -n $(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __SSP_ALL__) ]] || \
454 gcc-specs-ssp-all
455}
456
457# DEPRECATED - use gcc-specs-ssp from toolchain-funcs
458# indicate whether code for SSP is being generated
310has_ssp() { 459has_ssp() {
460 ewarn "has_ssp: deprecated, please use gcc-specs-ssp()!" >&2
461
462 # note; this matches both -fstack-protector and -fstack-protector-all
311 [ "${CFLAGS/-fstack-protector}" != "${CFLAGS}" ] && return 0 463 [[ ${CFLAGS/-fstack-protector} != ${CFLAGS} || \
312 test_version_info ssp && return 0 464 -n $(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __SSP__) ]] || \
313 return 1 465 gcc-specs-ssp
314} 466}
315 467
316has_m64() { 468has_m64() {
317 # this doesnt test if the flag is accepted, it tests if the flag 469 # this doesnt test if the flag is accepted, it tests if the flag
318 # actually -WORKS-. non-multilib gcc will take both -m32 and -m64! 470 # actually -WORKS-. non-multilib gcc will take both -m32 and -m64!
319 # please dont replace this function with test_flag in some future 471 # please dont replace this function with test_flag in some future
320 # clean-up! 472 # clean-up!
321 temp=`mktemp` 473
474 local temp="$(emktemp)"
322 echo "int main() { return(0); }" > ${temp}.c 475 echo "int main() { return(0); }" > "${temp}".c
323 ${CC/ .*/} -m64 -o /dev/null ${temp}.c > /dev/null 2>&1 476 MY_CC=$(tc-getCC)
324 ret=$? 477 ${MY_CC/ .*/} -m64 -o "$(emktemp)" "${temp}".c > /dev/null 2>&1
478 local ret=$?
325 rm -f ${temp}.c 479 rm -f "${temp}".c
326 [ "$ret" != "1" ] && return 0 480 [[ ${ret} != 1 ]] && return 0
327 return 1 481 return 1
328} 482}
329 483
330has_m32() { 484has_m32() {
331 # this doesnt test if the flag is accepted, it tests if the flag 485 # this doesnt test if the flag is accepted, it tests if the flag
332 # actually -WORKS-. non-multilib gcc will take both -m32 and -m64! 486 # actually -WORKS-. non-multilib gcc will take both -m32 and -m64!
333 # please dont replace this function with test_flag in some future 487 # please dont replace this function with test_flag in some future
334 # clean-up! 488 # clean-up!
335 temp=`mktemp` 489
490 [ "$(tc-arch)" = "amd64" ] && has_multilib_profile && return 0
491
492 local temp=$(emktemp)
336 echo "int main() { return(0); }" > ${temp}.c 493 echo "int main() { return(0); }" > "${temp}".c
337 ${CC/ .*/} -m32 -o /dev/null ${temp}.c > /dev/null 2>&1 494 MY_CC=$(tc-getCC)
338 ret=$? 495 ${MY_CC/ .*/} -m32 -o "$(emktemp)" "${temp}".c > /dev/null 2>&1
496 local ret=$?
339 rm -f ${temp}.c 497 rm -f "${temp}".c
340 [ "$ret" != "1" ] && return 0 498 [[ ${ret} != 1 ]] && return 0
341 return 1 499 return 1
342} 500}
343 501
344replace-sparc64-flags() { 502replace-sparc64-flags() {
345 local SPARC64_CPUS="ultrasparc v9" 503 local SPARC64_CPUS="ultrasparc3 ultrasparc v9"
346 504
347 if [ "${CFLAGS/mtune}" != "${CFLAGS}" ]; then 505 if [ "${CFLAGS/mtune}" != "${CFLAGS}" ]; then
348 for x in ${SPARC64_CPUS}; do 506 for x in ${SPARC64_CPUS}; do
349 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8}" 507 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8}"
350 done 508 done
351 else 509 else
352 for x in ${SPARC64_CPUS}; do 510 for x in ${SPARC64_CPUS}; do
353 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}" 511 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}"
354 done 512 done
355 fi 513 fi
356 514
357 if [ "${CXXFLAGS/mtune}" != "${CXXFLAGS}" ]; then 515 if [ "${CXXFLAGS/mtune}" != "${CXXFLAGS}" ]; then
358 for x in ${SPARC64_CPUS}; do 516 for x in ${SPARC64_CPUS}; do
359 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8}" 517 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8}"
360 done 518 done
361 else 519 else
362 for x in ${SPARC64_CPUS}; do 520 for x in ${SPARC64_CPUS}; do
363 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}" 521 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}"
364 done 522 done
365 fi 523 fi
366 524
367 export CFLAGS CXXFLAGS 525 export CFLAGS CXXFLAGS
368} 526}
369 527
370append-ldflags() { 528append-ldflags() {
529 [[ -z $* ]] && return 0
371 export LDFLAGS="${LDFLAGS} $*" 530 export LDFLAGS="${LDFLAGS} $*"
372 return 0 531 return 0
373} 532}
374 533
534# Remove flags from LDFLAGS - it's up to the ebuild to filter
535# CFLAGS and CXXFLAGS via filter-flags if they need to.
375filter-ldflags() { 536filter-ldflags() {
376 local x 537 _filter-var LDFLAGS "$@"
538 return 0
539}
377 540
378 # we do this fancy spacing stuff so as to not filter 541# Turn C style ldflags (-Wl,-foo) into straight ldflags - the results
379 # out part of a flag ... we want flag atoms ! :D 542# are suitable for passing directly to 'ld'; note LDFLAGS is usually passed
380 LDFLAGS=" ${LDFLAGS} " 543# to gcc where it needs the '-Wl,'.
544raw-ldflags() {
545 local x input="$@"
546 [[ -z ${input} ]] && input=${LDFLAGS}
547 set --
381 for x in "$@" ; do 548 for x in ${input} ; do
382 LDFLAGS="${LDFLAGS// ${x} / }" 549 x=${x#-Wl,}
550 set -- "$@" ${x//,/ }
383 done 551 done
384 LDFLAGS="${LDFLAGS:1:${#LDFLAGS}-2}" 552 echo "$@"
385 export LDFLAGS
386 return 0
387} 553}
388 554
389etexec-flags() { 555# Gets the flags needed for "NOW" binding
390 # if you're not using a hardened compiler you wont need this 556bindnow-flags() {
391 # PIC/no-pic kludge in the first place. 557 case $($(tc-getLD) -v 2>&1 </dev/null) in
392 has_hardened || return 0 558 *GNU* | *'with BFD'*) # GNU ld
393 559 echo "-Wl,-z,now" ;;
394 if has_pie || has_pic; then 560 *Apple*) # Darwin ld
395 [ -z "`is-flag -fno-pic`" ] && 561 echo "-bind_at_load" ;;
396 export CFLAGS="${CFLAGS} `test_flag -fno-pic`" 562 *)
397 [ -z "`is-flag -nopie`" ] && 563 # Some linkers just recognize -V instead of -v
398 export CFLAGS="${CFLAGS} `test_flag -nopie`" 564 case $($(tc-getLD) -V 2>&1 </dev/null) in
399 fi 565 *Solaris*) # Solaris accept almost the same GNU options
400 return 0 566 echo "-Wl,-z,now" ;;
567 esac
568 ;;
569 esac
401} 570}
402 571
403fstack-flags() { 572
404 if has_ssp; then 573# Some tests for when we screw with things and want to make
405 [ -z "`is-flag -fno-stack-protector`" ] && 574# sure we didn't break anything
406 export CFLAGS="${CFLAGS} `test_flag -fno-stack-protector`" 575#TESTS() {
407 fi 576# CFLAGS="-a -b -c=1"
408 return 0 577# CXXFLAGS="-x -y -z=2"
409} 578# LDFLAGS="-l -m -n=3"
579#
580# die() { exit 1; }
581# (is-flag 1 2 3) && die
582# (is-ldflag 1 2 3) && die
583#
584# is-flagq -l && die
585# is-ldflagq -a && die
586# is-flagq -a || die
587# is-flagq -x || die
588# is-ldflagq -n=* || die
589# is-ldflagq -n && die
590#
591# strip-unsupported-flags
592# [[ ${CFLAGS} == "-c=1" ]] || die
593# [[ ${CXXFLAGS} == "-y -z=2" ]] || die
594#
595# echo "All tests pass"
596#}
597#TESTS

Legend:
Removed from v.1.62  
changed lines
  Added in v.1.117

  ViewVC Help
Powered by ViewVC 1.1.20